=== specification/requirements.txt ===
# Optional but recommended for check spec links
termcolor

# Optional but recommended for check spec links on Windows
colorama

# Optional but recommended for check spec links
tabulate

# Optional but recommended: needed for scripts/xml_consistency.py
networkx

# Optional: bundled copy may be in ../external/python
jinja2
