=== debian/changelog ===
openxr-sdk-source (1.0.9~dfsg1-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Fri, 10 Jul 2020 17:24:22 -0500

openxr-sdk-source (1.0.9~dfsg1-1) unstable; urgency=medium

  * New upstream version 1.0.9~dfsg1. Highlights include:
    - New extensions in the headers.
    - Fix crashes in the layers.
    - Small loader improvements.
  * Rediff patches.
    - Drop 0011-hello_xr-vulkan-Fix-build-with-Vulkan-headers-1.2.13.patch:
      Incorporated upstream.
  * d/copyright: Update
  * d/rules: Remove outdated override
  * d/libopenxr-loader1.symbols: Add symbols file
  * Convert Markdown upstream changelogs to HTML and install both plain and
    html.

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Fri, 10 Jul 2020 12:17:40 -0500

openxr-sdk-source (1.0.8~dfsg1-3~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Andrew Lee (李健秋) <ajqlee@debian.org>  Fri, 08 May 2020 13:06:37 +0800

openxr-sdk-source (1.0.8~dfsg1-3) unstable; urgency=medium

  * Add 0011-hello_xr-vulkan-Fix-build-with-Vulkan-headers-1.2.13.patch
    - Closes: #958837

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Mon, 04 May 2020 10:43:06 -0500

openxr-sdk-source (1.0.8~dfsg1-2) unstable; urgency=medium

  * Source only upload for unblock migration to testing.

 -- Andrew Lee (李健秋) <ajqlee@debian.org>  Wed, 01 Apr 2020 16:19:17 +0800

openxr-sdk-source (1.0.8~dfsg1-1) unstable; urgency=medium

  * New upstream version 1.0.8~dfsg1
  * d/watch: Update repack suffix.
  * Rediff patches
    - This drops the following patches now included upstream:
      0004-gfxwrapper-Fix-type-mismatch.patch
      0008-loader_test-Adjust-runtime-manifest-generation-so-it.patch
      0005-Fix-hello_xr-error-only-seen-in-autopkgtest.patch
      0006-Loader-test-Adjust-to-match-specification.patch
      0007-loader_test-Improve-the-dummy-runtime-so-we-can-run-.patch
    - Drop 0006-build-Build-loader-api-layers-with-all-available-pla.patch
      as it is no longer needed with the single-instance loader.
  * d/control: Add Multi-Arch: same to -dev and API layers
  * Use upstreamed manpages.
  * d/rules: Add -Wl,--as-needed to improve dpkg-shlibdeps warnings.
  * Update d/copyright

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Tue, 31 Mar 2020 17:29:20 -0500

openxr-sdk-source (1.0.6~dfsg1-2) unstable; urgency=medium

  * Source only upload for unblock migration to testing.

 -- Andrew Lee (李健秋) <ajqlee@debian.org>  Mon, 23 Mar 2020 16:26:39 +0800

openxr-sdk-source (1.0.6~dfsg1-1) unstable; urgency=medium

  * Initial Release. (Closes: #943349)

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Mon, 16 Mar 2020 09:39:52 -0500
