=== debian/tests/control ===
Tests: build-runtime-list
Depends: @builddeps@, @, build-essential, pkg-config
Restrictions: superficial

Tests: build-hello-xr-opengl-xlib
Depends: @builddeps@, @, build-essential, pkg-config, libgl1-mesa-dev, libxrandr-dev, libxxf86vm-dev, mesa-common-dev
Restrictions: superficial

Tests: build-hello-xr-vulkan-xlib
Depends: @builddeps@, @, build-essential, pkg-config, libvulkan-dev
Restrictions: superficial
